Package org.eclipse.cdt.core.dom.ast.cpp

# Interface ICPPASTUnaryExpression

All Superinterfaces:
  `IASTExpression`, `IASTImplicitDestructorNameOwner`, `IASTImplicitNameOwner`, `IASTInitializerClause`, `IASTNode`, `IASTUnaryExpression`, `ICPPASTExpression`, `ICPPASTInitializerClause`

public interface ICPPASTUnaryExpression extends IASTUnaryExpression, ICPPASTExpression, IASTImplicitNameOwner

Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`IASTExpression.ValueCategory`

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`op_throw`
`op_throw` throw exp
`static final int`
`op_typeid`
`op_typeid` = typeid( exp )

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`EMPTY_EXPRESSION_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTImplicitDestructorNameOwner

`IMPLICIT_DESTRUCTOR_NAME`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTImplicitNameOwner

`IMPLICIT_NAME`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTUnaryExpression

`op_alignOf, op_amper, op_bracketedPrimary, op_integerPack, op_labelReference, op_minus, op_noexcept, op_not, op_plus, op_postFixDecr, op_postFixIncr, op_prefixDecr, op_prefixIncr, op_sizeof, op_sizeofParameterPack, op_star, op_tilde, op_typeof, OPERAND`

## Method Summary

Modifier and Type
Method
Description
`ICPPASTUnaryExpression`
`copy()`
Returns a mutable copy of the tree rooted at this node.
`ICPPASTUnaryExpression`
`copy(IASTNode.CopyStyle style)`
Returns a mutable copy of the tree rooted at this node.
`ICPPFunction`
`getOverload()`
Returns the function binding for the overloaded operator, or `null` if the operator is not overloaded.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`getExpressionType, getValueCategory, isLValue`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTImplicitDestructorNameOwner

`getImplicitDestructorNames`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTImplicitNameOwner

`getImplicitNames`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTUnaryExpression

`getOperand, getOperator, setOperand, setOperator`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.cpp.ICPPASTInitializerClause

`getEvaluation`

## Field Details

### op_throw

static final int op_throw
`op_throw` throw exp

See Also:
  - Constant Field Values

### op_typeid

static final int op_typeid
`op_typeid` = typeid( exp )

See Also:
  - Constant Field Values

## Method Details

### copy

ICPPASTUnaryExpression copy()
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTExpression`
Specified by:
  `copy` in interface `IASTInitializerClause`
Specified by:
  `copy` in interface `IASTNode`
Specified by:
  `copy` in interface `IASTUnaryExpression`
Since:
  5.1

### copy

ICPPASTUnaryExpression copy(IASTNode.CopyStyle style)
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTExpression`
Specified by:
  `copy` in interface `IASTInitializerClause`
Specified by:
  `copy` in interface `IASTNode`
Specified by:
  `copy` in interface `IASTUnaryExpression`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.
Since:
  5.3

### getOverload

ICPPFunction getOverload()
Returns the function binding for the overloaded operator, or `null` if the operator is not overloaded.

Since:
  5.4